var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import VCFDataFetcher from './vcf-fetcher';
import MyWorkerWeb from 'raw-loader!../dist/worker.js';
import { spawn, BlobWorker } from 'threads';
import { PILEUP_COLORS } from './vcf-utils';
import sanitizeHtml from 'sanitize-html';

var createColorTexture = function createColorTexture(PIXI, colors) {
  var colorTexRes = Math.max(2, Math.ceil(Math.sqrt(colors.length)));
  var rgba = new Float32Array(Math.pow(colorTexRes, 2) * 4);
  colors.forEach(function (color, i) {
    // eslint-disable-next-line prefer-destructuring
    rgba[i * 4] = color[0]; // r
    // eslint-disable-next-line prefer-destructuring
    rgba[i * 4 + 1] = color[1]; // g
    // eslint-disable-next-line prefer-destructuring
    rgba[i * 4 + 2] = color[2]; // b
    // eslint-disable-next-line prefer-destructuring
    rgba[i * 4 + 3] = color[3]; // a
  });

  return [PIXI.Texture.fromBuffer(rgba, colorTexRes, colorTexRes), colorTexRes];
};

function invY(p, t) {
  return (p - t.y) / t.k;
}

var scaleScalableGraphics = function scaleScalableGraphics(graphics, xScale, drawnAtScale) {
  var tileK = (drawnAtScale.domain()[1] - drawnAtScale.domain()[0]) / (xScale.domain()[1] - xScale.domain()[0]);
  var newRange = xScale.domain().map(drawnAtScale);

  var posOffset = newRange[0];
  graphics.scale.x = tileK;
  graphics.position.x = -posOffset * tileK;
};

var getTilePosAndDimensions = function getTilePosAndDimensions(zoomLevel, tilePos, binsPerTileIn, tilesetInfo) {
  /**
   * Get the tile's position in its coordinate system.
   *
   * TODO: Replace this function with one imported from
   * HGC.utils.trackUtils
   */
  var xTilePos = tilePos[0];
  var yTilePos = tilePos[1];

  if (tilesetInfo.resolutions) {
    // the default bins per tile which should
    // not be used because the right value should be in the tileset info

    var binsPerTile = binsPerTileIn;

    var sortedResolutions = tilesetInfo.resolutions.map(function (x) {
      return +x;
    }).sort(function (a, b) {
      return b - a;
    });

    var chosenResolution = sortedResolutions[zoomLevel];

    var _tileWidth = chosenResolution * binsPerTile;
    var _tileHeight = _tileWidth;

    var _tileX = chosenResolution * binsPerTile * tilePos[0];
    var _tileY = chosenResolution * binsPerTile * tilePos[1];

    return {
      tileX: _tileX,
      tileY: _tileY,
      tileWidth: _tileWidth,
      tileHeight: _tileHeight
    };
  }

  // max_width should be substitutable with 2 ** tilesetInfo.max_zoom
  var totalWidth = tilesetInfo.max_width;
  var totalHeight = tilesetInfo.max_width;

  var minX = tilesetInfo.min_pos[0];
  var minY = tilesetInfo.min_pos[1];

  var tileWidth = totalWidth / Math.pow(2, zoomLevel);
  var tileHeight = totalHeight / Math.pow(2, zoomLevel);

  var tileX = minX + xTilePos * tileWidth;
  var tileY = minY + yTilePos * tileHeight;

  return {
    tileX: tileX,
    tileY: tileY,
    tileWidth: tileWidth,
    tileHeight: tileHeight
  };
};

function eqSet(as, bs) {
  return as.size === bs.size && all(isIn(bs), as);
}

function all(pred, as) {
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = as[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var a = _step.value;
      if (!pred(a)) return false;
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return true;
}

function isIn(as) {
  return function (a) {
    return as.has(a);
  };
}

var GnomadTrack = function GnomadTrack(HGC) {
  for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  if (!new.target) {
    throw new Error('Uncaught TypeError: Class constructor cannot be invoked without "new"');
  }

  var GnomadTrackClass = function (_HGC$tracks$Tiled1DPi) {
    _inherits(GnomadTrackClass, _HGC$tracks$Tiled1DPi);

    function GnomadTrackClass(context, options) {
      _classCallCheck(this, GnomadTrackClass);

      var worker = spawn(BlobWorker.fromText(MyWorkerWeb));
      // this is where the threaded tile fetcher is called
      context.dataConfig['maxTileWidth'] = options.maxTileWidth;
      context.dataFetcher = new VCFDataFetcher(context.dataConfig, worker, HGC);

      var _this = _possibleConstructorReturn(this, (GnomadTrackClass.__proto__ || Object.getPrototypeOf(GnomadTrackClass)).call(this, context, options));

      context.dataFetcher.track = _this;

      _this.worker = worker;
      _this.valueScaleTransform = HGC.libraries.d3Zoom.zoomIdentity;

      _this.trackId = _this.id;
      _this.viewId = context.viewUid;

      // we scale the entire view up until a certain point
      // at which point we redraw everything to get rid of
      // artifacts
      // this.drawnAtScale keeps track of the scale at which
      // we last rendered everything
      _this.drawnAtScale = HGC.libraries.d3Scale.scaleLinear();
      _this.variantList = [];

      // graphics for highliting reads under the cursor
      _this.mouseOverGraphics = new HGC.libraries.PIXI.Graphics();
      _this.loadingText = new HGC.libraries.PIXI.Text('Loading', {
        fontSize: '12px',
        fontFamily: 'Arial',
        fill: 'grey'
      });

      _this.loadingText.x = 40;
      _this.loadingText.y = 110;

      _this.loadingText.anchor.x = 0;
      _this.loadingText.anchor.y = 0;

      _this.fetching = new Set();
      _this.rendering = new Set();

      _this.isShowGlobalMousePosition = context.isShowGlobalMousePosition;

      if (_this.options.showMousePosition && !_this.hideMousePosition) {
        _this.hideMousePosition = HGC.utils.showMousePosition(_this, _this.is2d, _this.isShowGlobalMousePosition());
      }

      _this.pLabel.addChild(_this.loadingText);
      _this.setUpShaderAndTextures();

      // Used for axis labels and horizontal lines
      _this.legendGraphics = new HGC.libraries.PIXI.Graphics();
      _this.pForeground.addChild(_this.legendGraphics);

      // Create the legend text here once
      _this.legendTextsBase = [];
      _this.legendTextsExponent = [];

      var pixiTextOptions = {
        fontSize: '12px',
        fontFamily: 'Arial',
        fill: '#333333'
      };

      var pixiTextSmOptions = {
        fontSize: '8px',
        fontFamily: 'Arial',
        fill: '#333333'
      };

      _this.legendTextsBase.push(new HGC.libraries.PIXI.Text('0', pixiTextOptions));
      for (var i = 5; i > 0; i--) {
        var base = new HGC.libraries.PIXI.Text('10', pixiTextOptions);
        _this.legendTextsBase.push(base);

        var exp = new HGC.libraries.PIXI.Text('-' + i, pixiTextSmOptions);
        _this.legendTextsExponent.push(exp);
      }
      _this.legendTextsBase.push(new HGC.libraries.PIXI.Text('1', pixiTextOptions));
      return _this;
    }

    _createClass(GnomadTrackClass, [{
      key: 'initTile',
      value: function initTile(tile) {
        tile.bgGraphics = new HGC.libraries.PIXI.Graphics();
        tile.graphics.addChild(tile.bgGraphics);
      }
    }, {
      key: 'getLabelPositions',
      value: function getLabelPositions() {
        var trackHeight = this.dimensions[1];
        var numLabels = this.legendTextsBase.length;
        var dist = trackHeight / numLabels;
        var labelPositions = [];

        for (var k = 0; k < numLabels; k++) {
          labelPositions.push(dist * k + this.options.variantHeight / 2);
        }
        return labelPositions;
      }
    }, {
      key: 'getBoundsOfTile',
      value: function getBoundsOfTile(tile) {
        // get the bounds of the tile
        var tileId = +tile.tileId.split('.')[1];
        var zoomLevel = +tile.tileId.split('.')[0]; //track.zoomLevel does not always seem to be up to date
        var tileWidth = +this.tilesetInfo.max_width / Math.pow(2, zoomLevel);
        var tileMinX = this.tilesetInfo.min_pos[0] + tileId * tileWidth; // abs coordinates
        var tileMaxX = this.tilesetInfo.min_pos[0] + (tileId + 1) * tileWidth;

        return [tileMinX, tileMaxX];
      }
    }, {
      key: 'setUpShaderAndTextures',
      value: function setUpShaderAndTextures() {
        var colorDict = PILEUP_COLORS;

        if (this.options && this.options.colorScale) {
          var _options$colorScale$m = this.options.colorScale.map(function (x) {
            return x;
          });

          var _options$colorScale$m2 = _slicedToArray(_options$colorScale$m, 5);

          colorDict.VARIANT = _options$colorScale$m2[0];
          colorDict.INSERTION = _options$colorScale$m2[1];
          colorDict.DELETION = _options$colorScale$m2[2];
          colorDict.INVERSION = _options$colorScale$m2[3];
          colorDict.DUPLICATION = _options$colorScale$m2[4];
        }

        var colors = Object.values(colorDict);

        var _createColorTexture = createColorTexture(HGC.libraries.PIXI, colors),
            _createColorTexture2 = _slicedToArray(_createColorTexture, 2),
            colorMapTex = _createColorTexture2[0],
            colorMapTexRes = _createColorTexture2[1];

        var uniforms = new HGC.libraries.PIXI.UniformGroup({
          uColorMapTex: colorMapTex,
          uColorMapTexRes: colorMapTexRes
        });
        this.shader = HGC.libraries.PIXI.Shader.from('\n    attribute vec2 position;\n    attribute float aColorIdx;\n\n    uniform mat3 projectionMatrix;\n    uniform mat3 translationMatrix;\n\n    uniform sampler2D uColorMapTex;\n    uniform float uColorMapTexRes;\n\n    varying vec4 vColor;\n\n    void main(void)\n    {\n        // Half a texel (i.e., pixel in texture coordinates)\n        float eps = 0.5 / uColorMapTexRes;\n        float colorRowIndex = floor((aColorIdx + eps) / uColorMapTexRes);\n        vec2 colorTexIndex = vec2(\n          (aColorIdx / uColorMapTexRes) - colorRowIndex + eps,\n          (colorRowIndex / uColorMapTexRes) + eps\n        );\n        vColor = texture2D(uColorMapTex, colorTexIndex);\n\n        gl_Position = vec4((projectionMatrix * translationMatrix * vec3(position, 1.0)).xy, 0.0, 1.0);\n    }\n\n', '\nvarying vec4 vColor;\n\n    void main(void) {\n        gl_FragColor = vColor;\n    }\n', uniforms);
      }
    }, {
      key: 'rerender',
      value: function rerender(options) {
        _get(GnomadTrackClass.prototype.__proto__ || Object.getPrototypeOf(GnomadTrackClass.prototype), 'rerender', this).call(this, options);

        this.options = options;

        if (this.options.showMousePosition && !this.hideMousePosition) {
          this.hideMousePosition = HGC.utils.showMousePosition(this, this.is2d, this.isShowGlobalMousePosition());
        }

        if (!this.options.showMousePosition && this.hideMousePosition) {
          this.hideMousePosition();
          this.hideMousePosition = undefined;
        }

        this.setUpShaderAndTextures();
        this.updateExistingGraphics();
      }
    }, {
      key: 'createLegendGraphics',
      value: function createLegendGraphics() {
        var _this2 = this;

        this.legendGraphics.clear();

        var trackHeight = this.dimensions[1];
        var numLabels = this.legendTextsBase.length;
        var dist = trackHeight / numLabels;

        this.legendGraphics.beginFill(HGC.utils.colorToHex('#ffffff'));
        this.legendGraphics.drawRect(0, 0, 30, trackHeight);

        this.legendTextsBase.forEach(function (pixiText, k) {
          pixiText.x = 2;
          pixiText.y = dist * k + _this2.options.variantHeight / 2;
          pixiText.anchor.x = 0;
          pixiText.anchor.y = 0.5;
          _this2.legendGraphics.addChild(pixiText);
        });

        this.legendTextsExponent.forEach(function (pixiText, k) {
          pixiText.x = 17;
          pixiText.y = dist * (k + 1);
          pixiText.anchor.x = 0;
          pixiText.anchor.y = 0;
          _this2.legendGraphics.addChild(pixiText);
        });
      }
    }, {
      key: 'renderTileBackground',
      value: function renderTileBackground(tile) {
        if (!tile) {
          return;
        }
        tile.bgGraphics.removeChildren();
        tile.bgGraphics.clear();

        var bounds = this.getBoundsOfTile(tile);
        tile.tileMinX = bounds[0];
        tile.tileMaxX = bounds[1];
        var minX = this._xScale(tile.tileMinX);
        var maxX = this._xScale(tile.tileMaxX);

        tile.bgGraphics.beginFill(HGC.utils.colorToHex('#ebebeb'));

        var labelPositions = this.getLabelPositions();

        labelPositions.forEach(function (posY) {
          tile.bgGraphics.drawRect(minX, posY, maxX - minX, 1);
        });
      }
    }, {
      key: 'updateExistingGraphics',
      value: function updateExistingGraphics() {
        var _this3 = this;

        this.loadingText.text = 'Rendering...';

        this.createLegendGraphics();
        this.visibleTileIds.forEach(function (tileId) {
          _this3.renderTileBackground(_this3.fetchedTiles[tileId]);
        });

        if (!eqSet(this.visibleTileIds, new Set(Object.keys(this.fetchedTiles)))) {
          this.updateLoadingText();
          return;
        }

        var fetchedTileKeys = Object.keys(this.fetchedTiles);
        fetchedTileKeys.forEach(function (x) {
          _this3.fetching.delete(x);
          _this3.rendering.add(x);
        });
        this.updateLoadingText();

        this.worker.then(function (tileFunctions) {
          tileFunctions.renderSegments(_this3.dataFetcher.uid, Object.values(_this3.fetchedTiles).map(function (x) {
            return x.remoteId;
          }), _this3._xScale.domain(), _this3._xScale.range(), _this3.options, _this3.getLabelPositions()).then(function (toRender) {
            _this3.loadingText.visible = false;
            fetchedTileKeys.forEach(function (x) {
              _this3.rendering.delete(x);
            });
            _this3.updateLoadingText();

            _this3.errorTextText = null;
            _this3.pBorder.clear();
            _this3.drawError();
            _this3.animate();

            _this3.positions = new Float32Array(toRender.positionsBuffer);
            _this3.colors = new Float32Array(toRender.colorsBuffer);
            _this3.ixs = new Int32Array(toRender.ixBuffer);

            var newGraphics = new HGC.libraries.PIXI.Graphics();

            _this3.variantList = toRender.variants;

            var geometry = new HGC.libraries.PIXI.Geometry().addAttribute('position', _this3.positions, 2); // x,y
            geometry.addAttribute('aColorIdx', _this3.colors, 1);
            geometry.addIndex(_this3.ixs);

            if (_this3.positions.length) {
              var state = new HGC.libraries.PIXI.State();
              var mesh = new HGC.libraries.PIXI.Mesh(geometry, _this3.shader, state);

              newGraphics.addChild(mesh);
            }

            _this3.pMain.x = _this3.position[0];

            if (_this3.segmentGraphics) {
              _this3.pMain.removeChild(_this3.segmentGraphics);
            }

            _this3.pMain.addChild(newGraphics);
            _this3.segmentGraphics = newGraphics;

            // remove and add again to place on top
            _this3.pMain.removeChild(_this3.mouseOverGraphics);
            _this3.pMain.addChild(_this3.mouseOverGraphics);

            _this3.drawnAtScale = HGC.libraries.d3Scale.scaleLinear().domain(toRender.xScaleDomain).range(toRender.xScaleRange);

            scaleScalableGraphics(_this3.segmentGraphics, _this3._xScale, _this3.drawnAtScale);

            // if somebody zoomed vertically, we want to readjust so that
            // they're still zoomed in vertically
            _this3.segmentGraphics.scale.y = _this3.valueScaleTransform.k;
            _this3.segmentGraphics.position.y = _this3.valueScaleTransform.y;

            _this3.draw();
            _this3.animate();
          });
        });
      }
    }, {
      key: 'updateLoadingText',
      value: function updateLoadingText() {
        this.loadingText.visible = true;
        this.loadingText.text = '';

        if (!this.tilesetInfo) {
          this.loadingText.text = 'Fetching tileset info...';
          return;
        }

        if (this.fetching.size) {
          this.loadingText.text = 'Fetching... ' + [].concat(_toConsumableArray(this.fetching)).map(function (x) {
            return x.split('|')[0];
          }).join(' ');
        }

        if (this.rendering.size) {
          this.loadingText.text = 'Rendering... ' + [].concat(_toConsumableArray(this.rendering)).join(' ');
        }

        if (!this.fetching.size && !this.rendering.size) {
          this.loadingText.visible = false;
        }
      }
    }, {
      key: 'draw',
      value: function draw() {
        this.trackNotFoundText.text = 'Track not found.';
        this.trackNotFoundText.visible = true;
      }
    }, {
      key: 'getMouseOverHtml',
      value: function getMouseOverHtml(trackX, trackYIn) {
        var _this4 = this;

        // const trackY = this.valueScaleTransform.invert(track)
        this.mouseOverGraphics.clear();
        // Prevents 'stuck' read outlines when hovering quickly
        requestAnimationFrame(this.animate);
        var trackY = invY(trackYIn, this.valueScaleTransform);
        var vHeight = this.options.variantHeight * this.valueScaleTransform.k;

        var filteredList = this.variantList.filter(function (variant) {
          return _this4._xScale(variant.from) <= trackX && trackX <= _this4._xScale(variant.to) && trackY >= variant.yTop + 1 && trackY <= variant.yTop + vHeight + 1;
        });

        var variantHtml = '';
        var typeHtml = '';
        var positionHtml = '';
        var alleleCountHtml = '';
        var alleleFrequencyHtml = '';
        var alleleNumberHtml = '';
        var sourceHtml = '';
        var svLength = '';

        var fontStyle = 'line-height: 12px;font-family: monospace;font-size:14px;';

        var _iteratorNormalCompletion2 = true;
        var _didIteratorError2 = false;
        var _iteratorError2 = undefined;

        try {
          for (var _iterator2 = filteredList[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
            var variant = _step2.value;

            var variantFrom = this._xScale(variant.from);
            var variantTo = this._xScale(variant.to);

            // draw outline
            var width = variantTo - variantFrom;

            this.mouseOverGraphics.lineStyle({
              width: 1,
              color: 0
            });
            this.mouseOverGraphics.drawRect(variantFrom, variant.yTop, width, vHeight);
            this.animate();

            var vRef = variant.ref.match(/.{1,15}/g).join('<br>');
            var vAlt = variant.alt.match(/.{1,15}/g).join('<br>');

            if (variant.category === "SNV") {
              variantHtml += '<td style=\'' + fontStyle + ' padding-right:5px;\'><strong>' + vRef + ' &rarr; ' + vAlt + '</strong></td>';
              positionHtml += '<td>' + variant.chrName + ':' + (variant.from - variant.chrOffset) + '</td>';
              sourceHtml += '<td>gnomAD</td>';
            } else {
              variantHtml += '<td>Structural variant</td>';
              positionHtml += '<td>' + variant.chrName + ':' + (variant.from - variant.chrOffset) + '-' + variant.chrName + ':' + (variant.to - variant.chrOffset) + '</td>';
              sourceHtml += '<td>gnomAD-SV</td>';
              svLength += '<td>' + variant.info['SVLEN'] + '</td>';
            }

            typeHtml += '<td>' + this.capitalizeFirstLetter(variant.type) + '</td>';
            alleleCountHtml += '<td>' + variant.alleleCount + '</td>';
            var af = Number.parseFloat(variant.alleleFrequency).toExponential(4);
            alleleFrequencyHtml += '<td>' + af + '</td>';
            alleleNumberHtml += '<td>' + variant.alleleNumber + '</td>';
          }
        } catch (err) {
          _didIteratorError2 = true;
          _iteratorError2 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion2 && _iterator2.return) {
              _iterator2.return();
            }
          } finally {
            if (_didIteratorError2) {
              throw _iteratorError2;
            }
          }
        }

        if (filteredList.length > 0) {
          var mouseOverHtml = '<table>' + ('<tr><td>Variant:</td>' + variantHtml + '</tr>') + ('<tr><td>Type:</td>' + typeHtml + '</tr>') + ('<tr><td>Position:</td>' + positionHtml + '</tr>');

          if (svLength.length > 0) {
            mouseOverHtml += '<tr><td>SV length:</td>' + svLength + '</tr>';
          }

          mouseOverHtml += '<tr><td>Allele Count:</td>' + alleleCountHtml + '</tr>' + ('<tr><td>Allele Frequency:</td>' + alleleFrequencyHtml + '</tr>') + ('<tr><td>Allele Number:</td>' + alleleNumberHtml + '</tr>') + ('<tr><td>Source:</td>' + sourceHtml + '</tr>') + '</table>';

          return sanitizeHtml(mouseOverHtml);
        }

        return '';
      }
    }, {
      key: 'capitalizeFirstLetter',
      value: function capitalizeFirstLetter(string) {
        return string.charAt(0).toUpperCase() + string.slice(1);
      }
    }, {
      key: 'calculateZoomLevel',
      value: function calculateZoomLevel() {
        return HGC.utils.trackUtils.calculate1DZoomLevel(this.tilesetInfo, this._xScale, this.maxZoom);
      }
    }, {
      key: 'calculateVisibleTiles',
      value: function calculateVisibleTiles() {
        var tiles = HGC.utils.trackUtils.calculate1DVisibleTiles(this.tilesetInfo, this._xScale);

        var _iteratorNormalCompletion3 = true;
        var _didIteratorError3 = false;
        var _iteratorError3 = undefined;

        try {
          for (var _iterator3 = tiles[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
            var tile = _step3.value;

            var _getTilePosAndDimensi = getTilePosAndDimensions(tile[0], [tile[1]], this.tilesetInfo.tile_size, this.tilesetInfo),
                tileX = _getTilePosAndDimensi.tileX,
                tileWidth = _getTilePosAndDimensi.tileWidth;

            var DEFAULT_MAX_TILE_WIDTH = this.options.maxTileWidth || 2e5;

            if (tileWidth > DEFAULT_MAX_TILE_WIDTH) {
              this.errorTextText = 'Zoom in to see details';
              this.drawError();
              this.animate();
              return;
            }

            this.errorTextText = null;
            this.pBorder.clear();
            this.drawError();
            this.animate();
          }
        } catch (err) {
          _didIteratorError3 = true;
          _iteratorError3 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion3 && _iterator3.return) {
              _iterator3.return();
            }
          } finally {
            if (_didIteratorError3) {
              throw _iteratorError3;
            }
          }
        }

        this.setVisibleTiles(tiles);
      }
    }, {
      key: 'setPosition',
      value: function setPosition(newPosition) {
        _get(GnomadTrackClass.prototype.__proto__ || Object.getPrototypeOf(GnomadTrackClass.prototype), 'setPosition', this).call(this, newPosition);

        var _position = _slicedToArray(this.position, 2);

        this.pMain.position.x = _position[0];
        this.pMain.position.y = _position[1];

        var _position2 = _slicedToArray(this.position, 2);

        this.pMouseOver.position.x = _position2[0];
        this.pMouseOver.position.y = _position2[1];

        var _newPosition = _slicedToArray(newPosition, 2);

        this.loadingText.x = _newPosition[0];
        this.loadingText.y = _newPosition[1];

        this.loadingText.x += 30;
      }
    }, {
      key: 'movedY',
      value: function movedY(dY) {
        var vst = this.valueScaleTransform;
        var height = this.dimensions[1];

        // clamp at the bottom and top
        if (vst.y + dY / vst.k > -(vst.k - 1) * height && vst.y + dY / vst.k < 0) {
          this.valueScaleTransform = vst.translate(0, dY / vst.k);
        }

        // this.segmentGraphics may not have been initialized if the user
        // was zoomed out too far
        if (this.segmentGraphics) {
          this.segmentGraphics.position.y = this.valueScaleTransform.y;
        }

        this.animate();
      }
    }, {
      key: 'zoomedY',
      value: function zoomedY(yPos, kMultiplier) {
        var newTransform = HGC.utils.trackUtils.zoomedY(yPos, kMultiplier, this.valueScaleTransform, this.dimensions[1]);

        this.valueScaleTransform = newTransform;
        this.segmentGraphics.scale.y = newTransform.k;
        this.segmentGraphics.position.y = newTransform.y;

        this.mouseOverGraphics.clear();
        this.animate();
      }
    }, {
      key: 'zoomed',
      value: function zoomed(newXScale, newYScale) {
        _get(GnomadTrackClass.prototype.__proto__ || Object.getPrototypeOf(GnomadTrackClass.prototype), 'zoomed', this).call(this, newXScale, newYScale);

        if (this.segmentGraphics) {
          scaleScalableGraphics(this.segmentGraphics, newXScale, this.drawnAtScale);
        }

        this.mouseOverGraphics.clear();
        this.animate();
      }
    }, {
      key: 'exportSVG',
      value: function exportSVG() {
        var track = null;
        var base = null;

        if (_get(GnomadTrackClass.prototype.__proto__ || Object.getPrototypeOf(GnomadTrackClass.prototype), 'exportSVG', this)) {
          var _get$call = _get(GnomadTrackClass.prototype.__proto__ || Object.getPrototypeOf(GnomadTrackClass.prototype), 'exportSVG', this).call(this);

          var _get$call2 = _slicedToArray(_get$call, 2);

          base = _get$call2[0];
          track = _get$call2[1];
        } else {
          base = document.createElement('g');
          track = base;
        }

        var output = document.createElement('g');
        track.appendChild(output);

        output.setAttribute('transform', 'translate(' + this.pMain.position.x + ',' + this.pMain.position.y + ') scale(' + this.pMain.scale.x + ',' + this.pMain.scale.y + ')');

        var gSegment = document.createElement('g');

        gSegment.setAttribute('transform', 'translate(' + this.segmentGraphics.position.x + ',' + this.segmentGraphics.position.y + ')' + ('scale(' + this.segmentGraphics.scale.x + ',' + this.segmentGraphics.scale.y + ')'));

        output.appendChild(gSegment);

        if (this.segmentGraphics) {
          var b64string = HGC.services.pixiRenderer.plugins.extract.base64(
          // this.segmentGraphics, 'image/png', 1,
          this.pMain.parent.parent);

          var gImage = document.createElement('g');

          gImage.setAttribute('transform', 'translate(0,0)');

          var image = document.createElement('image');
          image.setAttributeNS('http://www.w3.org/1999/xlink', 'xlink:href', b64string);
          gImage.appendChild(image);
          gSegment.appendChild(gImage);

          // gSegment.appendChild(image);
        }

        return [base, base];
      }
    }]);

    return GnomadTrackClass;
  }(HGC.tracks.Tiled1DPixiTrack);

  return new (Function.prototype.bind.apply(GnomadTrackClass, [null].concat(args)))();
};

var icon = '<svg width="16" height="16" xmlns="http://www.w3.org/2000/svg"> <!-- Created with Method Draw - http://github.com/duopixel/Method-Draw/ --> <g> <title>background</title> <rect fill="#fff" id="canvas_background" height="18" width="18" y="-1" x="-1"/> <g display="none" overflow="visible" y="0" x="0" height="100%" width="100%" id="canvasGrid"> <rect fill="url(#gridpattern)" stroke-width="0" y="0" x="0" height="100%" width="100%"/> </g> </g> <g> <title>Layer 1</title> <rect id="svg_1" height="0.5625" width="2.99997" y="3.21586" x="1.18756" stroke-width="1.5" stroke="#999999" fill="#000"/> <rect id="svg_3" height="0.5625" width="2.99997" y="7.71582" x="6.06252" stroke-width="1.5" stroke="#999999" fill="#000"/> <rect id="svg_4" height="0.5625" width="2.99997" y="3.21586" x="1.18756" stroke-width="1.5" stroke="#999999" fill="#000"/> <rect id="svg_5" height="0.5625" width="2.99997" y="3.90336" x="11.49997" stroke-width="1.5" stroke="#f73500" fill="#000"/> <rect id="svg_6" height="0.5625" width="2.99997" y="7.40333" x="11.62497" stroke-width="1.5" stroke="#999999" fill="#000"/> <rect id="svg_7" height="0.5625" width="2.99997" y="13.90327" x="5.93752" stroke-width="1.5" stroke="#f4f40e" fill="#000"/> </g> </svg>';

GnomadTrack.config = {
  type: 'gnomad',
  datatype: ['vcf'],
  orientation: '1d-horizontal',
  name: 'Gnomad Track',
  thumbnail: new DOMParser().parseFromString(icon, 'text/xml').documentElement,
  availableOptions: ['colorScale', 'showMousePosition', 'variantHeight', 'maxTileWidth'
  // 'minZoom'
  ],
  defaultOptions: {
    colorScale: [
    // Variant, Insertion, Deletion, Inversion, Duplication
    [0.3, 0.3, 0.3, 0.6], [0.6, 0.6, 0.0, 0.7], [1, 0.0, 0.0, 0.55], [0.68, 0.23, 0.87, 0.8], [0.27, 0.64, 0.09, 0.8]],
    showMousePosition: false,
    variantHeight: 12,
    maxTileWidth: 2e5
  },
  optionsInfo: {

    colorScale: {
      name: 'Color scheme',
      inlineOptions: {
        default: {
          value: [
          // Variant, Insertion, Deletion, Inversion, Duplication
          [0.3, 0.3, 0.3, 0.6], [0.6, 0.6, 0.0, 0.7], [1, 0.0, 0.0, 0.55], [0.68, 0.23, 0.87, 0.8], [0.27, 0.64, 0.09, 0.8]],
          name: 'Default'
        }
      }
    }
  }
};

export default GnomadTrack;