var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DEBOUNCE_TIME = 200;

var VCFDataFetcher = function () {
  function VCFDataFetcher(dataConfig, worker, HGC) {
    var _this = this;

    _classCallCheck(this, VCFDataFetcher);

    this.dataConfig = dataConfig;
    this.uid = HGC.libraries.slugid.nice();
    this.worker = worker;
    this.prevRequestTime = 0;

    this.toFetch = new Set();
    this.fetchTimeout = null;

    this.tbiIndexed = null;
    this.tbiVCFParser = null;

    this.initPromise = this.worker.then(function (tileFunctions) {
      if (!dataConfig.tbiUrl) {
        dataConfig['tbiUrl'] = dataConfig['vcfUrl'] + '.tbi';
      }

      return tileFunctions.init(_this.uid, dataConfig.vcfUrl, dataConfig.tbiUrl, dataConfig.chromSizesUrl, dataConfig.maxTileWidth).then(function () {
        return _this.worker;
      });
    });
  }

  _createClass(VCFDataFetcher, [{
    key: 'tilesetInfo',
    value: function tilesetInfo(callback) {
      var _this2 = this;

      console.log('tilesetInfo');
      this.worker.then(function (tileFunctions) {
        tileFunctions.tilesetInfo(_this2.uid).then(callback);
      });
    }
  }, {
    key: 'fetchTilesDebounced',
    value: function fetchTilesDebounced(receivedTiles, tileIds) {
      var _this3 = this;

      var toFetch = this.toFetch;


      var thisZoomLevel = tileIds[0].split('.')[0];
      var toFetchZoomLevel = toFetch.size ? [].concat(_toConsumableArray(toFetch))[0].split('.')[0] : null;

      if (thisZoomLevel !== toFetchZoomLevel) {
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = this.toFetch[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var tileId = _step.value;

            this.track.fetching.delete(tileId);
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }

        this.toFetch.clear();
      }

      tileIds.forEach(function (x) {
        return _this3.toFetch.add(x);
      });

      if (this.fetchTimeout) {
        clearTimeout(this.fetchTimeout);
      }

      this.fetchTimeout = setTimeout(function () {
        _this3.sendFetch(receivedTiles, [].concat(_toConsumableArray(_this3.toFetch)));
        _this3.toFetch.clear();
      }, DEBOUNCE_TIME);
    }
  }, {
    key: 'sendFetch',
    value: function sendFetch(receivedTiles, tileIds) {
      var _this4 = this;

      this.track.updateLoadingText();

      this.worker.then(function (tileFunctions) {
        tileFunctions.fetchTilesDebounced(_this4.uid, tileIds).then(receivedTiles);
      });
    }
  }]);

  return VCFDataFetcher;
}();

export default VCFDataFetcher;